program Shellsortas;

const N = 9;

{ paprastas masyvas }
var mas : array [1..N] of integer;


{********************************************}
procedure inicializuoti_mas;
  var i : integer;
begin
  for i := 1 to N do mas[i] := 0
end;


function rasti_mas (sk : integer) : boolean;
  var i : integer;
      b : boolean;
begin
  b := false;
  for i := 1 to N do
    if mas[i] = sk then
    begin
      b := true;
      break
    end;
  rasti_mas := b
end;


procedure uzpildyti_mas;
  var i, val : integer;
begin
  inicializuoti_mas ();
  randomize;
  for i := 1 to N do
  begin
    repeat
      val := 1 + random (99)
    until not rasti_mas(val);
    mas[i] := val
  end
end;



procedure spausdinti_mas;
  var i : integer;
begin
  for i := 1 to N do write (' ', mas[i]);
  writeln
end;

{********************************************}

procedure shellsort;
    var i, j, v, h : integer;
begin
    h := 1; repeat h := 3*h+1 until h>N;
    repeat
        h := h div 3;
        for i := h+1 to N do
        begin
            v := mas[i];
             j := i;
            while (j > h) and (mas[j-h] > v) do
                begin mas[j] := mas[j-h];
                 j := j-h;
                 end;
            mas[j] := v
        end
    until h = 1;
end;


{********************************************}

begin
  writeln ('Sveiki. Programuosime.');
  writeln;
  uzpildyti_mas ();
  write ('Nerusiuotas masyvas atrodo taip:');
  spausdinti_mas ();
  readln();
  writeln ('Didejanciai surusiuotas masyvas:');
  shellsort();
  spausdinti_mas ();
  readln();
  writeln('baigta');
  readln;

  end.
